import java.awt.*;

/*
 *
 * Graph
 *
 */
public final class Graph extends Canvas
{

	static Rectangle rr;
	static Graphics gg;
	static double table[][];
	static Color clist [];
	static double scale[];
	static int rows,cols;


	public Graph(int lines)
	{
		reset(lines);
	}
	
	public void reset(int lines)
	{
		scale = new double[4];
		scale[0]=0;scale[1]=0;scale[2]=1;scale[3]=1;
		clist = new Color[8];
		clist[0]=Color.red;
		clist[1]=Color.blue;
		clist[2]=Color.green;
		clist[3]=Color.magenta;
		clist[4]=Color.orange;
		clist[5]=Color.pink;
		clist[6]=Color.cyan;
		clist[7]=Color.yellow;
		if (lines > 8) cols = 9;
		else cols=lines+1;

		rows=0;

	}

	public void setScale(double x, double y, double width, double height)
	{
		scale[0]=x;
		scale[1]=y;
		scale[2]=width;
		scale[3]=height;
	}

	public void addRow(double x[])
	{
		double temp[][];
		temp=new double[rows+1][cols];
		for (int i=0; i<rows; i++)
		{
			for(int j=0; j<cols; j++)
			{
				temp[i][j]=table[i][j];
			}
		}
		for(int j=0; j<cols; j++) temp[rows][j]=x[j];
		rows=rows+1;
		table=temp;
	}

	
	public void paint(Graphics  g)
	{
		Rectangle r; Point p1,p2,p3;
		g.setColor(Color.white);
		r=g.getClipRect();
		rr=r;
		gg=g;

		g.fillRect(r.x, r.y, r.width, r.height);

		g.setColor(Color.lightGray);

		coordLine(scale[0],0,scale[0]+scale[2],0);
		coordLine(0,scale[1],0,scale[1]+scale[3]);


		g.setColor(Color.black);

		coordLine(scale[0],scale[1],scale[0],scale[1]+scale[3]);
		coordLine(scale[0],scale[1],scale[0]+scale[2],scale[1]);
		coordLine(scale[0],scale[1]+scale[3],scale[0]+scale[2],scale[1]+scale[3]);
		coordLine(scale[0]+scale[2],scale[1],scale[0]+scale[2],scale[1]+scale[3]);


		for(int i=2;i<=rows;i++)
		{
			for(int j=2;j<=cols;j++)
			{
				g.setColor(clist[j-2]);
				coordLine(table[i-2][0],table[i-2][j-1],table[i-1][0],table[i-1][j-1]);
			}
		}

	}

	private Point coord(double x, double y)
	{
		Point result;
		result=new Point(0,0);
		result.x=(int)((rr.width-1)*(x-scale[0])/scale[2]);
		result.y=(int)(rr.y+rr.height-1-((rr.height-1)*(y-scale[1])/scale[3]));
		return result;
	 
	}
	


	private void coordLine(double x1, double y1, double x2, double y2)
	{
		Point p1,p2;
		p1=coord(x1,y1);
		p2=coord(x2,y2);
		gg.drawLine(p1.x,p1.y,p2.x,p2.y);
	}
}

